"use strict";
let shouldInitializeExtension = true;

// 状態を表す定数
const TAB_STATE = {
  IDLE: 0,
  EXECUTE_ABILITY_SHORT_WAIT: 1,  // 1⇒2　回復後のアビ実行(短wait)
  EXECUTE_ABILITY_NORTMAL: 2,     // 2⇒2⇒リトライ終了時0 
  EXECUTE_JUDGE_RESULT: 3,        // 3⇒1　アビ実行結果が気絶の場合は、回復⇒アビ実行
  EXECUTE_RECOVERY_DP: 10,        // 10⇒0 任務回復薬を使用する
  EXECUTE_GET_ABILITY_FORM: 100,  // 編成アビ
  EXECUTE_GET_ABILITY_EQUIP: 101, // 所持アビ
  EXECUTE_GET_FORMATION: 110,     // 編成情報取得
  EXECUTE_GET_PROFILE: 200,       // ユーザ情報取得
};

console.log("★content.js start ----------------");
stateCheck();

async function stateCheck() {
  const currentUrl = window.location.href;
  //console.log("★★stateCheck start currentUrl:", currentUrl);

  const tabId = await getTabId();
  let tabState = await loadTabState(tabId);

  const battleState = await getBattleStatus();
  console.log("bs:", battleState);

  console.log('Loaded tab state:', tabState);
  if (tabState.status && tabState.retryCount > 0) {
    const elapsedTime = await getElapsedTime(tabState);
    console.log("elapsedTime:", elapsedTime);

    // 水鏡終了判定
    //if (battleState.ogi1 && battleState.ogi1 == "発:天依鏡殺") {
    if (battleState && battleState.ogi1 && battleState.ogi1 == "発:水鏡煌環") {
      if (battleState.ogiRemain1 > 0 && battleState.ogiRemain1 <= 5) {
        // 残り時間が5秒以内の場合はリトライ終了
        console.log("リトライ終了:", battleState.ogi1);
        displayStatus(`水鏡残り${battleState.ogiRemain1}秒: リトライ終了`);
        clearTabState();
        return;
      }
    }

    if (tabState.status === TAB_STATE.EXECUTE_ABILITY_SHORT_WAIT) {
      let waitTime = await getWaitTime(settingId);
      await handleNormalExecution(tabState, waitTime, elapsedTime);
    } else if (tabState.status === TAB_STATE.EXECUTE_ABILITY_NORTMAL) {
      const aid = await extractAidString(tabState.url);
      if (aid == "3D50") {
        const tabStateToSave = {
          status: TAB_STATE.EXECUTE_JUDGE_RESULT,
          retryCount: tabState.retryCount,
          retryTotal: tabState.retryTotal,
          text: "通常弓",
          url: tabState.url,
          waitTime: tabState.waitTime
        };
        await saveTabState(tabId, tabStateToSave);
        stateCheckResult();
        return;
      }
      else {
        // 通常処理 主に後衛
        const currentUrl = window.location.href;
        if (currentUrl.includes("battle_error.aspx")) {
          displayStatus(`${tabState.text} リトライ中 残り${tabState.retryCount}回`);
          var message = extractNaviMessage(); // エラーメッセージ取得
          console.log("navi_message:", message);
          if (message.includes("終了したよ")) {
            await clearTabState();
          }
          else if (message.includes("限られた回数") ||
            message.includes("装備されていない") ||
            message.includes("使用できないみたい")) {
            // ボタン一時無効化
            const aid = await extractAidString(tabState.url);
            console.log("aid:", aid);
            await clearStatus();
            await clearTabState();
            disableButton(aid);
          }
        }
        await handleNormalExecution(tabState, tabState.waitTime, elapsedTime);
      }
    } else {
      stateCheckResult();
      return;
    }

    // 再読み込み
    tabState = await loadTabState(tabId);


    if (tabState.retryCount <= 0) {
      tabState.status = TAB_STATE.IDLE;
    }

    const tabStateToSave = {
      status: tabState.status,
      retryCount: tabState.retryCount,
      retryTotal: tabState.retryTotal,
      text: tabState.text,
      url: tabState.url,
      waitTime: tabState.waitTime
    };
    await saveTabState(tabId, tabStateToSave);

    if (tabState.retryCount >= 0) {
      console.log("▶攻撃実行 retry:", tabState.retryCount);
      shouldInitializeExtension = false;
      await window.location.assign(tabState.url);
    }
  }
}


//　コンテンツ(アビ実行結果etc)を判定
async function stateCheckResult() {
  const tabId = await getTabId();
  const tabState = await loadTabState(tabId);
  //console.log('stateCheckResult:', tabState);

  if (tabState.status && tabState.retryCount > 0) {
    const currentUrl = window.location.href;
    //console.log("currentUrl:", currentUrl);

    if (tabState.status === TAB_STATE.EXECUTE_JUDGE_RESULT) {
      // アビ実行結果取得
      if (currentUrl.includes("Ferror%2F400.aspx")) {
        // アク禁
        console.log("アク禁");
        await clearStatus();
        await clearTabState();
        bsleep(3000);
        return;
      }
      else if (currentUrl.includes("item_detail.aspx")) {
        console.log("任務P回復ルート");

      }
      else if (currentUrl.includes("battle_error.aspx")) {
        displayStatus(`${tabState.text} リトライ中 残り${tabState.retryCount}回`);

        var message = extractNaviMessage(); // エラーメッセージ取得
        if(0){
          const texts = ["攻撃を受けて気絶", "攻撃を受けて気絶", "すでにこの決戦は終了したよ"];
          const randomNumber = Math.floor(Math.random() * texts.length);
          message = texts[randomNumber];
        }

        console.log("navi_message:", message);
        if (message.includes("攻撃を受けて気絶")) {
          //回復処理　⇒アビ実行(state:1)
          await bsleep(800);
          console.log("攻撃失敗ルート: 回復実行");
          executeRecovery(tabState);
          return;
        }
        else if (message.includes("TPが足りない")) {
          displayMessage(`「自動任務」を実行します。`, true);
          await executeDuty(10, 360);
          //await saveTabState(tabId, tabState);
        }
        else if (message.includes("終了したよ")) {
          if (0) {
            displayMessage(`「自動任務」を実行します。`, true);
            console.log("自動任務: 5回");
            await executeDuty(5, 350);
          }
          if (0) { //debug
            await bsleep(800);
            console.log("決戦時間外 回復debug");
            tabState.retryCount -= 1;
            await executeRecovery(tabState);
            //executeAbility(tabState);
            return;
          }
          if (0) {
            // ボタン一時無効化
            const aid = await extractAidString(tabState.url);
            console.log("aid:", aid);
            disableButton(aid);
          }
          if (0) {
            await bsleep(3000);
            const tabStateToSave = {
              status: tabState.status,
              retryCount: tabState.retryCount - 1,
              retryTotal: tabState.retryTotal,
              text: tabState.text,
              url: tabState.url,
              waitTime: tabState.waitTime
            };
            await saveTabState(tabId, tabStateToSave);
            location.reload();
          }
          if (0) {
            const aid = await extractAidString(tabState.url);
            disableButton(aid);
          }
          console.log("状態クリア");
          await clearStatus();
          await clearTabState();
          //return;
        }
        else if (message.includes("相手がみんな気絶")) {
          // TPチェック
          const currentTP = 100;
          if (currentTP < 90) {
            // 任務実行
            displayMessage(`「自動任務」を実行します。`, true);
            console.log("自動任務: 5回");
            await executeDuty(5, 350);
            await saveTabState(tabId, tabState);
          }
          else {
            //displayStatus(`リトライ中 残り${tabState.retryCount}回`);
            await bsleep(1000 + (1000 / tabState.retryCount));
            window.location.assign(tabState.url);
            return;
          }
        }
        else if (message.includes("限られた回数") ||
          message.includes("装備されていない") ||
          message.includes("使用できないみたい")) {
          // ボタン一時無効化
          const aid = await extractAidString(tabState.url);
          console.log("aid:", aid);
          await clearStatus();
          await clearTabState();
          disableButton(aid);
        }
        else if (message.includes("連続実行")) {
          bsleep(1500);
          window.location.assign(tabState.url);
          return;
        }
        else {
          console.log("その他エラー", currentUrl);
          bsleep(1000);
          window.location.assign(tabState.url);
          return;
        }
      }
      else {
        console.log("その他URL:", currentUrl);
        tabState.retryCount -= 1;
        if (tabState.retryCount) {
          displayStatus(`${tabState.text} リトライ中 残り${tabState.retryCount}回`);
          const tabStateToSave = {
            status: TAB_STATE.EXECUTE_JUDGE_RESULT,
            retryCount: tabState.retryCount,
            retryTotal: tabState.retryTotal,
            text: tabState.text,
            url: tabState.url,
            waitTime: tabState.waitTime
          };
          await saveTabState(tabId, tabStateToSave);
          console.log("▶攻撃実行 status 3⇒3");
          window.location.assign(tabState.url);
        }
        else {
          // status初期化
          await clearTabState();
        }
      }
    }
    else if (tabState.status === TAB_STATE.EXECUTE_RECOVERY_DP) {
      console.log("route 10");
      if (currentUrl.includes("stamina_shortage.asp")) {
        await clearTabState();
        // ボタンを取得
        var btnUse = document.getElementById('body_btnUse');
        console.log("任務P切れ url:", tabState.url);
        window.location.assign(tabState.url);
        return;
      }
      else if (currentUrl.includes("item_detail.aspx%3Feid%3D1")) {
        // ボタンを取得
        var btnUse = document.getElementById('body_btnUse');
        console.log("任務P切れ(所持品画面):", btnUse);
        if (btnUse) {
          // ボタンをクリック
          await bsleep(2000);
          btnUse.click();
        }
        await clearTabState(); // state 10⇒0
      }
      else {
        console.log("想定外ルート url:", currentUrl);
      }
    }
  }
}


if (shouldInitializeExtension) {
  //console.log('addEventListener: DOMContentLoaded');
  document.addEventListener("DOMContentLoaded", initializeExtension);
}


async function initializeExtension() {

  const tabId = await getTabId();
  const settingId = await getSettingId(tabId);
  //const settingName = await getsettingName(settingId);
  //console.log("★★initializeExtension start", settingId);
  const buttonSize = await getButtonSize(settingId);
  //console.log("buttonSize:",buttonSize);


  if (settingId === TAB_STATE.EXECUTE_GET_ABILITY_FORM) {
    handleGetButtonData();
  } else if (settingId === TAB_STATE.EXECUTE_GET_ABILITY_EQUIP) {
    getAbilityFromEquip();
  } else if (settingId === TAB_STATE.EXECUTE_GET_FORMATION) {
    // カード編成
    getFormation();
  } else if (settingId === 200) {
    handlecheckLicense();
  } else {
    createStatusElement();
    createMenu(settingId);
    createStatusMessageElement();
    //console.log("★★initializeExtension end");
  }
}


// ボタン設定用編成情報取得
async function handleGetButtonData() {
  if (document.readyState === "complete" || document.readyState === "interactive") {
    getButtonsData();
  } else {
    document.addEventListener("DOMContentLoaded", getButtonsData);
  }
  await bsleep(500);
  chrome.runtime.sendMessage({ type: 'closeTab' });
}


// ユーザ情報取得
function handlecheckLicense() {
  if (document.readyState === "complete" || document.readyState === "interactive") {
    getProfile();
  } else {
    document.addEventListener("DOMContentLoaded", getProfile)
  }
  chrome.runtime.sendMessage({ type: 'closeTab' });
}


// アビ実行
async function handleNormalExecution(tabState, waitTime, elapsedTime) {
  if (waitTime > elapsedTime) {
    const sleep = tabState.waitTime - elapsedTime;
    console.log("bsleep:", sleep);
    await bsleep(sleep);
  }
  tabState.retryCount -= 1;
}


// navi_message取得
function extractNaviMessage() {
  var messageElement = document.getElementById('navi_message');
  // 要素が存在するか確認
  if (messageElement) {
    // 要素のテキストコンテンツを取得
    var message = messageElement.textContent.trim();
    return message;
  } else {
    return null;  // 要素が存在しない場合はnullを返すなど、適切な処理を行う
  }
}


// HTMLからユーザ情報を抽出する関数
async function getProfile() {
  var profile = [];

  // ユーザ名
  const element = document.querySelector('.bar-green');
  const uname = element.textContent.match(/(.+)の/)[1];
  // uid
  const uid = document.getElementById('body_divStatus').innerHTML.match(/u=(\d+)/)[1];
  console.log(uid);
  //gid
  const gid = document.getElementById('body_hlGuildName').href.match(/gid%(3D\d+)/)[1];
  console.log(gid);

  profile.push({ uname: uname, uid: uid, gid: gid });

  // ローカルストレージに保存
  await new Promise((resolve) => {
    chrome.storage.local.set({ 'Profile': profile }, function () {
      console.log('Data saved to local storage:', profile);
      resolve();
    });
  });
}


// リンクボタン処理
async function handleSelection(e, selection) {
  let n = selection || e.target;
  let label = n && n.getAttribute && n.getAttribute("data-action");

  // オプション設定取得
  const tabId = await getTabId();
  const settingId = await getSettingId(tabId);
  let waitTime = await getWaitTime(settingId);
  const recoveryOption = await getRecoveryOption(settingId);
  //console.log("label:", label);

  if (label) {
    // ボタンタイプを取得 (linkB1 -> B, linkL1 -> L, linkR1 -> R)
    const buttonType = label[4];
    const buttonSettings = await getButtonSettings(buttonType, settingId);

    if (label.includes("linkM")) {
      // メニューボタン処理
      processMenuButton(label);
    }
    else {
      // リンクボタン処理　labelに基づいて該当するボタンのURLを取得
      const buttonNumber = extractNumber(label);
      const jumpUrl = buttonNumber != null ? buttonSettings[buttonNumber - 1]?.url : null;
      let rUrl = await getRecoveryUrl(); // 回復用URL
      const buttonText = buttonNumber != null ? buttonSettings[buttonNumber - 1]?.text : null;
      let { repeatCount, interval } = await extractRepeatCountAndInterval(jumpUrl);

      console.log("label=", label, "repeatCount=", repeatCount, "interval=", interval);
      const shouldExecuteRecovery = recoveryOption === "on" && jumpUrl &&
        (
          jumpUrl.includes("3Faid%3D10") ||
          jumpUrl.includes("3Faid%3D11") ||
          jumpUrl.includes("3Faid%3D20%") ||
          (jumpUrl.includes("3Faid%3D10") && !/\d+$/.test(jumpUrl.slice(jumpUrl.indexOf("3Faid%3D10") + 10))) ||
          (jumpUrl.includes("3Faid%3D20") && !/\d+$/.test(jumpUrl.slice(jumpUrl.indexOf("3Faid%3D20") + 10))) ||
          (jumpUrl.includes("3Faid%3D40") && !/\d+$/.test(jumpUrl.slice(jumpUrl.indexOf("3Faid%3D40") + 10)))
          //(jumpUrl.match(/3Faid%3D(\d+)/) || [])[1] === "20" // 追加
        );

      //console.log("jumpUrl:", jumpUrl);
      //console.log("shouldExecuteRecovery:", shouldExecuteRecovery);
      const comboCheck = jumpUrl && /3Faid%3D2\d{3}/.test(jumpUrl);
      //console.log("comboCheck:", comboCheck);

      // ボタンのリンク有効時
      if (jumpUrl) {
        //console.log(`[${label}] jump start repeat=${repeatCount} interval=${interval}`);
        await clearTabState();
        // jumpUrlから#以降を削除
        let cleanJumpUrl = jumpUrl.split("#")[1] || jumpUrl;

        if (shouldExecuteRecovery) {
          const tabStateToSave = {
            status: TAB_STATE.EXECUTE_JUDGE_RESULT, // 回復前アビ実行
            retryCount: repeatCount,
            retryTotal: repeatCount,
            text: buttonText,
            url: cleanJumpUrl,
            waitTime: interval,
            waitTimeRecovery: waitTime
          };
          saveTabState(tabId, tabStateToSave);

          // 既に気絶画面の場合は、回復⇒攻撃実行
          // battleStatusで自身が気絶の場合も追加
          if (window.location.href.includes("battle_error.aspx") &&
            extractNaviMessage().includes("攻撃を受けて気絶")
          ) {
            console.log("▶前衛(気絶状態):回復⇒攻撃");
            executeRecovery(tabStateToSave);
            return;
          }
          else if (window.location.href.includes("battle_top_sp.aspx") &&
            getKzStatus()
          ) {
            // 決戦画面で、気絶中の場合
            console.log("▶前衛(気絶状態2):回復⇒攻撃");
            executeRecovery(tabStateToSave);
            return;
          }
          else {
            // アビを実行し、気絶などのエラー時はリトライする
            console.log("▶回復前アビ実行:", extractAidString(cleanJumpUrl));
            window.location.assign(cleanJumpUrl);
            return;
          }
        }
        else if (comboCheck) {
          // 後衛コンボチェックルート
          // 決戦画面の場合はコンボ状態チェック
        }

        if (repeatCount > 1) {
          if (jumpUrl.includes("duty_start.ashx")) {
            // 任務
            displayMessage(`「${buttonText}」を実行します。`, true);
            await executeDuty(repeatCount, interval);
          }
          else if (jumpUrl.includes("2Fgacha")) {
            //ガチャ
            displayMessage(`「${buttonText}」を実行します。`, true);
            console.log(`jumpUrl-repeat:`, cleanJumpUrl);
            for (let i = 1; i <= repeatCount; i++) {
              console.log(`jump i=${i}`);
              await fetch(cleanJumpUrl, { mode: 'no-cors', cache: 'no-cache' });
              await bsleep(interval);
            }
            displayMessage(`「${buttonText}」の実行が完了しました。`, true);
          }
          else {
            // 攻撃など
            displayMessage(`「${buttonText}」を実行します。`, true);
            console.log("▶アビ実行", cleanJumpUrl);
            // tab状態保存し、リロード
            const tabStateToSave = {
              status: TAB_STATE.EXECUTE_ABILITY_NORTMAL,
              retryCount: repeatCount - 1,
              retryTotal: repeatCount,
              text: buttonText,
              url: cleanJumpUrl,
              waitTime: interval
            };
            saveTabState(tabId, tabStateToSave);

            window.location.assign(cleanJumpUrl);
            //console.log("jumpUrl-attack repeat>1 end");
          }
        }
        else {
          const tabStateToSave = {
            status: TAB_STATE.EXECUTE_ABILITY_NORTMAL,
            retryCount: repeatCount - 1,
            retryTotal: repeatCount,
            text: buttonText,
            url: cleanJumpUrl,
            waitTime: interval
          };
          saveTabState(tabId, tabStateToSave);

          window.location.assign(cleanJumpUrl);
          console.log(`▶アビ実行(no repeat): ${cleanJumpUrl}`);
          return;
        }
      }
    }
  }
}


// メニュー
async function processMenuButton(label) {
  console.log("processMenuButton label:", label);
  await clearTabState();
  switch (label) {
    case "linkMPrevTab":
      chrome.runtime.sendMessage({ type: 'switchTab', direction: 'previous' });
      break;
    case "linkMNextTab":
      chrome.runtime.sendMessage({ type: 'switchTab', direction: 'next' });
      break;
    case "linkMOption":
      chrome.runtime.sendMessage({ type: 'openOptionsPage' });
      break;
    case "linkMDispButtons":
      console.log("表示ON/OFF");
      toggleHideLinkButtons();
      location.reload();
      break;
    case "linkMenu":
      //console.log("設定Menu");
      createAdvancedMenu();
      break;
    case "linkMUrl":
      // クリップボードにテキストをコピー
      navigator.clipboard.writeText(window.location.href);
      break;
    case "linkMAbout":
      console.log("About");
      chrome.runtime.sendMessage({
        action: "openPopup"
      });
      break;

    default:
  }
}


// 拡張メニュー
function processAdvancedMenuButton(label) {
  console.log("processMenuButton label:", label);
  switch (label) {
    case "linkA1":
      break;
    default:
  }
}


// リンクボタン非表示状態をトグルする関数
async function toggleHideLinkButtons() {
  // 現在の非表示状態を取得
  const currentHideLinkButtons = await getHideLinkButtons();
  // ローカルストレージにトグルした状態を保存
  await setHideLinkButtons(!currentHideLinkButtons);
  console.log('Toggled hideLinkButtons to', !currentHideLinkButtons);
}


// リンクボタン非表示設定関数
async function setHideLinkButtons(flg) {
  // ローカルストレージに表示フラグ保存
  await new Promise((resolve) => {
    chrome.storage.local.set({ 'hideLinkButtons': flg }, function () {
      console.log('Data saved hideLinkButtons', flg);
      resolve();
    });
  });
}


// リンクボタン非表示状態を取得する関数
async function getHideLinkButtons() {
  return new Promise((resolve) => {
    chrome.storage.local.get(['hideLinkButtons'], function (result) {
      const hideLinkButtons = result.hideLinkButtons;
      //console.log('Retrieved hideLinkButtons', hideLinkButtons);
      resolve(hideLinkButtons);
    });
  });
}


// 任務実行
async function executeDuty(repeatCount, interval) {
  let url = "https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fapi%2Fduty_start.ashx%3Fdi%3D811%26rnd%3D137405&guid=ON";
  let lastExecutionTimestamp = 0;
  //console.log("任務実行", repeatCount)

  let startTp = 0;
  let currentTp = 0;
  let currentDp = 0;

  const tabId = await getTabId();
  const tabState = await loadTabState(tabId);

  displayStatus(`任務実行中`);
  for (let i = 1; i <= repeatCount; i++) {
    console.log(`任務実行 i=${i}`);
    try {
      // fetchでレスポンスを取得
      const response = await fetch(url, { cache: 'no-cache' });

      // レスポンスが成功かつHTMLであるか確認
      if (response.ok && response.headers.get('content-type').includes('text/html')) {
        const html = await response.text();
        const parser = new DOMParser();
        const doc = parser.parseFromString(html, 'text/html');
        //console.log(html);

        // 任務P
        const elementDp = doc.getElementById('currentDutyPNum');
        if (elementDp) {
          currentDp = elementDp.textContent.trim();
        } else {
          await bsleep(interval);
          continue;
          // ここでエラーハンドリングを行うか、続行するかを決定する
        }

        //console.log("DP:", currentDp);
        if (currentDp < 10) {
          url = "https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fuser%2Fitem_detail.aspx%3Feid%3D100%26eic%3D1%26rnd%3D0&guid=ON"; // 回復薬
          const tabState = await loadTabState(tabId);
          tabState.status = 10; // 任務P回復実行
          tabState.retryCount = 1;
          tabState.url = url;
          tabState.text = "任務P回復";
          await saveTabState(tabId, tabState);
          console.log("▶任務P回復実行:");
          break;
        }

        // TP
        const elementTp = doc.getElementById('currentTpNum');
        currentTp = elementTp.textContent.trim();
        if (!startTp) {
          startTp = currentTp;
        }
        //console.log(currentTp);
        if (currentTp > startTp || currentTp > 90) {
          break;
        }

      } else {
        console.error('レスポンス異常。');
      }
    } catch (error) {
      console.error('自動任務でエラーが発生しました。', error);
      console.log(`TP:${currentTp}, DP:${currentDp}`);

      //任務Pが足りない

      if (currentDp < 10 && currentDp > 0) {
        console.log("任務P回復ルート");
        url = "https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fuser%2Fitem_detail.aspx%3Feid%3D100%26eic%3D1%26rnd%3D0&guid=ON";
        tabState.status = 10; // 任務P回復実行
        tabState.retryCount = 1;
        tabState.url = url;
        tabState.text = "任務P回復";
        await saveTabState(tabId, tabState);
        await window.location.assign(url);
        return;
      }
      else {
        console.log("ルート2");
        //break;
        //await window.location.assign(url);
      }
    }
    // 待機
    await bsleep(interval);
  }

  console.log(`TP:${currentTp}, DP:${currentDp}`);

  const currentUrl = window.location.href;

  //タイムスタンプ更新
  await bsleep(500);
  await saveTabState(tabId, tabState);

  //console.log("currentUrl:", currentUrl);
  console.log("JumpUrl:", url);


  if (currentTp >= 90 && !currentUrl.includes("battle_error.aspx")) {
    await clearTabState();
    location.reload();
  }
  else {
    window.location.assign(url);
    await new Promise(resolve => {
      window.addEventListener('load', resolve, { once: true });
    });
  }
}


// aid取得関数(ログ出力用)
function extractAidString(url) {
  const match = url.match(/aid%3D(\d+)/);
  return match ? `3D${match[1]}` : null;
}


// 自動回復処理
async function executeRecovery(tabState) {
  const tabId = await getTabId();
  const rUrl = await getRecoveryUrl(); // 回復用URL
  const settingId = await getSettingId(tabId);
  const waitTimeRecovery = await getWaitTime(settingId);

  // 回復
  tabState.status = TAB_STATE.EXECUTE_JUDGE_RESULT;
  await saveTabState(tabId, tabState);
  console.log("▶自動回復実行:", waitTimeRecovery);
  window.location.assign(rUrl);
  await bsleep(waitTimeRecovery);

  // アビ実行
  console.log("▶アビ実行", extractAidString(tabState.url));
  tabState.retryCount -= 1;
  var tabStateToSave = {
    status: TAB_STATE.IDLE,
    retryCount: tabState.retryCount,
    retryTotal: tabState.retryTotal,
    text: tabState.text,
    url: tabState.url,
    waitTime: tabState.interval
  };
  if (tabState.retryCount > 0) {
    tabStateToSave.status = tabState.status;
  }
  await saveTabState(tabId, tabStateToSave);
  await window.location.assign(tabState.url);

}
